/*******************************************************************************
* FILENAME: cyfitter_cfg.c
* PSoC Creator 2.2 Component Pack 5
*
* Description:
* This file is automatically generated by PSoC Creator with device 
* initialization code.  Except for the user defined sections in
* CyClockStartupError(), this file should not be modified.
*
********************************************************************************
* Copyright 2012, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
********************************************************************************/

#include <string.h>
#include <cytypes.h>
#include <cydevice_trm.h>
#include <cyfitter.h>
#include <CyLib.h>
#include <cyfitter_cfg.h>

/* Clock startup error codes                                                   */
#define CYCLOCKSTART_NO_ERROR    0u
#define CYCLOCKSTART_XTAL_ERROR  1u
#define CYCLOCKSTART_32KHZ_ERROR 2u
#define CYCLOCKSTART_PLL_ERROR   3u

#ifdef CY_NEED_CYCLOCKSTARTUPERROR
/*******************************************************************************
* Function Name: CyClockStartupError
********************************************************************************
* Summary:
*  If an error is encountered during clock configuration (crystal startup error,
*  PLL lock error, etc.), the system will end up here.  Unless reimplemented by
*  the customer, this function will stop in an infinite loop.
*
* Parameters:
*   void
*
* Return:
*   void
*
*******************************************************************************/
#if defined(__GNUC__) || defined(__ARMCC_VERSION)
__attribute__ ((unused))
#endif
static void CyClockStartupError(uint8 errorCode);
#if defined(__GNUC__) || defined(__ARMCC_VERSION)
__attribute__ ((unused))
#endif
static void CyClockStartupError(uint8 errorCode)
{
    /* To remove the compiler warning if errorCode not used.                */
    errorCode = errorCode;

    /* `#START CyClockStartupError` */

    /* If we have a clock startup error (bad MHz crystal, PLL lock, etc.),  */
    /* we will end up here to allow the customer to implement something to  */
    /* deal with the clock condition.                                       */

    /* `#END` */

    /* If nothing else, stop here since the clocks have not started         */
    /* correctly.                                                           */
    while(1) {}
}
#endif


#if defined(__C51__) || defined(__CX51__)
	#define CYPACKED
	#define CYALIGNED
	
	#define CY_CFG_MEMORY_BARRIER() do { } while (0)



	#define CYMEMZERO(a,c) cymemzero((a),(c))
	#define CYCONFIGCPY(d,s,c) cyconfigcpy((c),(s),(d))
	#define CYCONFIGCPYCODE(d,s,c) cyconfigcpycode((c),(s),(d))
#else
	#error Unsupported toolchain
#endif


/*******************************************************************************
* Function Name: ClockSetup
********************************************************************************
*
* Summary:
*  Performs the initialization of all of the clocks in the device based on the
*  settings in the Clock tab of the DWR.  This includes enabling the requested
*  clocks and setting the necessary dividers to produce the desired frequency. 
*
* Parameters:
*  void
*
* Return:
*  void
*
*******************************************************************************/
static void ClockSetup(void);
static void ClockSetup(void)
{
	uint32 timeout;
	uint8 pllLock;


	/* Configure Digital Clocks based on settings from Clock DWR */
	CY_SET_XTND_REG16((void CYFAR *)(CYREG_CLKDIST_DCFG0_CFG0), 0x0001u);
	CY_SET_REG8((void CYXDATA *)(CYREG_CLKDIST_DCFG0_CFG0 + 0x2), 0x18u);
	CY_SET_XTND_REG16((void CYFAR *)(CYREG_CLKDIST_DCFG1_CFG0), 0x752Fu);
	CY_SET_REG8((void CYXDATA *)(CYREG_CLKDIST_DCFG1_CFG0 + 0x2), 0x19u);

	/* Configure ILO based on settings from Clock DWR */
	CY_SET_REG8((void CYXDATA *)(CYREG_SLOWCLK_ILO_CR0), 0x02u);
	CY_SET_REG8((void CYXDATA *)(CYREG_CLKDIST_CR), 0x08u);

	/* Configure IMO based on settings from Clock DWR */
	CY_SET_REG8((void CYXDATA *)(CYREG_FASTCLK_IMO_CR), 0x03u);
	CY_SET_REG8((void CYXDATA *)(CYREG_IMO_TR1), (CY_GET_XTND_REG8((void CYFAR *)CYREG_FLSHID_CUST_TABLES_IMO_3MHZ)));

	/* Configure PLL based on settings from Clock DWR */
	CY_SET_XTND_REG16((void CYFAR *)(CYREG_FASTCLK_PLL_P), 0x0008u);
	CY_SET_XTND_REG16((void CYFAR *)(CYREG_FASTCLK_PLL_CFG0), 0x1051u);
	/* Wait up to 250us for the PLL to lock */
	pllLock = 0u;
	for (timeout = 250u / 10u; (timeout > 0u) && (pllLock != 0x03u); timeout--) { 
		pllLock = 0x03u & ((uint8)((uint8)pllLock << 1) | ((CY_GET_REG8((void CYXDATA *)CYREG_FASTCLK_PLL_SR) & 0x01u) >> 0));
		CyDelayCycles(10u * 48u); /* Delay 10us based on 48MHz clock */
	}

	/* Configure Bus/Master Clock based on settings from Clock DWR */
	CY_SET_XTND_REG16((void CYFAR *)(CYREG_CLKDIST_MSTR0), 0x0100u);
	CY_SET_REG8((void CYXDATA *)(CYREG_CLKDIST_MSTR0), 0x07u);
	CY_SET_REG8((void CYXDATA *)(CYREG_CLKDIST_BCFG0), 0x00u);
	CY_SET_REG8((void CYXDATA *)(CYREG_CLKDIST_BCFG2), 0x48u);
	CY_SET_REG8((void CYXDATA *)(CYREG_CLKDIST_MSTR0), 0x00u);
	CY_SET_REG8((void CYXDATA *)(CYREG_CLKDIST_LD), 0x02u);

	CY_SET_REG8((void CYXDATA *)(CYREG_PM_ACT_CFG2), ((CY_GET_REG8((void CYXDATA *)CYREG_PM_ACT_CFG2) | 0x03u)));
}


/* Analog API Functions */


/*******************************************************************************
* Function Name: AnalogSetDefault
********************************************************************************
*
* Summary:
*  Sets up the analog portions of the chip to default values based on chip
*  configuration options from the project.
*
* Parameters:
*  void
*
* Return:
*  void
*
*******************************************************************************/
static void AnalogSetDefault(void);
static void AnalogSetDefault(void)
{
	uint8 bg_xover_inl_trim = CY_GET_XTND_REG8((void CYFAR *)(CYREG_FLSHID_MFG_CFG_BG_XOVER_INL_TRIM + 1u));
	CY_SET_REG8((void CYXDATA *)CYREG_BG_DFT0, bg_xover_inl_trim & 0x07u);
	CY_SET_REG8((void CYXDATA *)CYREG_BG_DFT1, ((uint8)((uint8)bg_xover_inl_trim >> 4)) & 0x0Fu);
	CY_SET_REG8((void CYXDATA *)CYREG_PRT2_AG, 0x80u);
	CY_SET_REG8((void CYXDATA *)CYREG_CAPSL_CFG0, 0x00u);
	CY_SET_REG8((void CYXDATA *)CYREG_CMP2_SW3, 0x20u);
	CY_SET_REG8((void CYXDATA *)CYREG_DSM0_SW0, 0x09u);
	CY_SET_REG8((void CYXDATA *)CYREG_PUMP_CR0, 0x66u);
}


/*******************************************************************************
* Function Name: SetAnalogRoutingPumps
********************************************************************************
*
* Summary:
* Enables or disables the analog pumps feeding analog routing switches.
* Intended to be called at startup, based on the Vdda system configuration;
* may be called during operation when the user informs us that the Vdda voltage
* crossed the pump threshold.
*
* Parameters:
*  enabled - 1 to enable the pumps, 0 to disable the pumps
*
* Return:
*  void
*
*******************************************************************************/
void SetAnalogRoutingPumps(uint8 enabled)
{
	uint8 regValue = CY_GET_REG8((void CYXDATA *)CYREG_PUMP_CR0);
	if (enabled != 0u)
	{
		regValue |= 0x22u;
	}
	else
	{
		regValue &= (uint8)~0x22u;
	}
	CY_SET_REG8((void CYXDATA *)CYREG_PUMP_CR0, regValue);
}

#define CY_AMUX_UNUSED CYREG_BOOST_SR
/* This is an implementation detail of the AMux. Code that depends on it may be
   incompatible with other versions of PSoC Creator. */
uint8 CYXDATA * const CYCODE CapSense_AMuxCH0__addrTable[6] = {
	(uint8 CYXDATA *)CYREG_PRT0_AMUX, 
	(uint8 CYXDATA *)CYREG_PRT0_AMUX, 
	(uint8 CYXDATA *)CYREG_PRT0_AMUX, 
	(uint8 CYXDATA *)CYREG_DSM0_SW3, 
	(uint8 CYXDATA *)CYREG_CMP2_SW3, 
	(uint8 CYXDATA *)CYREG_DAC0_SW3, 
};

/* This is an implementation detail of the AMux. Code that depends on it may be
   incompatible with other versions of PSoC Creator. */
const uint8 CYCODE CapSense_AMuxCH0__maskTable[6] = {
	0x20u, 
	0x40u, 
	0x04u, 
	0x01u, 
	0x01u, 
	0x10u, 
};

/*******************************************************************************
* Function Name: CapSense_AMuxCH0_Set
********************************************************************************
* Summary:
*  This function is used to set a particular channel as active on the AMux.
*
* Parameters:  
*   channel - The mux channel input to set as active
*
* Return:
*   void
*
*******************************************************************************/
void CapSense_AMuxCH0_Set(uint8 channel)
{
	if (channel < 6)
	{
		*CapSense_AMuxCH0__addrTable[channel] |= CapSense_AMuxCH0__maskTable[channel];
	}
}

/*******************************************************************************
* Function Name: CapSense_AMuxCH0_Unset
********************************************************************************
* Summary:
*  This function is used to clear a particular channel from being active on the
*  AMux.
*
* Parameters:  
*   channel - The mux channel input to mark inactive
*
* Return:
*   void
*
*******************************************************************************/
void CapSense_AMuxCH0_Unset(uint8 channel)
{
	if (channel < 6)
	{
		*CapSense_AMuxCH0__addrTable[channel] &= (uint8)~CapSense_AMuxCH0__maskTable[channel];
	}
}



/*******************************************************************************
* Function Name: cyfitter_cfg
********************************************************************************
* Summary:
*  This function is called by the start-up code for the selected device. It
*  performs all of the necessary device configuration based on the design
*  settings.  This includes settings from the Design Wide Resources (DWR) such
*  as Clocks and Pins as well as any component configuration that is necessary.
*
* Parameters:  
*   void
*
* Return:
*   void
*
*******************************************************************************/
void cyfitter_cfg(void)
{
	/* IOPINS0_0 Address: CYREG_PRT0_DM0 Size (bytes): 8 */
	static const uint8 CYCODE BS_IOPINS0_0_VAL[] = {
		0x00u, 0x00u, 0x64u, 0x00u, 0x00u, 0x00u, 0x00u, 0x00u};

	/* IOPINS0_1 Address: CYREG_PRT1_DM0 Size (bytes): 8 */
	static const uint8 CYCODE BS_IOPINS0_1_VAL[] = {
		0x00u, 0x80u, 0x80u, 0x00u, 0x00u, 0x00u, 0x00u, 0x00u};

	/* IOPINS0_2 Address: CYREG_PRT2_DM0 Size (bytes): 8 */
	static const uint8 CYCODE BS_IOPINS0_2_VAL[] = {
		0x00u, 0x7Fu, 0x7Fu, 0x00u, 0x00u, 0x00u, 0x80u, 0x00u};

	/* Enable/Disable Debug functionality based on settings from System DWR */
	CY_SET_XTND_REG8((void CYFAR *)CYREG_MLOGIC_DEBUG, (CY_GET_XTND_REG8((void CYFAR *)CYREG_MLOGIC_DEBUG) | 0x05u));

	{
		static const uint8 CYCODE cfg_byte_table[] = {
			0x1Bu,
			0x00u, 0x52u, 0x03u, /* Base address 0x005200 */
			/* CYDEV_PRTDSI_PRT0_BASE */
			0x00u, 0x60u, 0x01u, 0x04u, 0x06u, 0x64u, 
			0x00u, 0x64u, 0x05u, /* Base address 0x006400 */
			/* CYDEV_UWRK_UWRK8_B0_BASE */
			0x06u, 0xFFu, 0x07u, 0xFFu, 0x17u, 0xFFu, 0x27u, 0xFFu, 
			/* CYDEV_UWRK_UWRK8_B0_BASE + 0x00000070u */
			0x85u, 0x1Fu, 
			0x00u, 0x65u, 0x04u, /* Base address 0x006500 */
			/* CYDEV_UWRK_UWRK8_B1_BASE */
			0x07u, 0xFFu, 0x17u, 0xFFu, 0x27u, 0xFFu, 
			/* CYDEV_UWRK_UWRK8_B1_BASE + 0x00000070u */
			0x85u, 0x7Fu, 
			0x01u, 0x03u, 0x02u, /* Base address 0x010300 */
			/* CYDEV_UCFG_B0_P1_ROUTE_BASE + 0x00000080u */
			0x87u, 0x02u, 0xE4u, 0x02u, 
			0x01u, 0x04u, 0x45u, /* Base address 0x010400 */
			/* CYDEV_UCFG_B0_P2_U0_BASE */
			0x00u, 0x01u, 0x03u, 0x10u, 0x06u, 0x02u, 0x0Au, 0x04u, 0x0Bu, 0x02u, 0x0Cu, 0x09u, 0x0Eu, 0x10u, 0x0Fu, 0x09u, 
			0x10u, 0x01u, 0x14u, 0x01u, 0x15u, 0x0Bu, 0x18u, 0x10u, 0x19u, 0x0Au, 0x1Au, 0x08u, 0x1Bu, 0x01u, 0x1Eu, 0x01u, 
			0x1Fu, 0x04u, 0x21u, 0x09u, 0x23u, 0x02u, 0x24u, 0x18u, 0x28u, 0x10u, 0x2Eu, 0x01u, 0x30u, 0x02u, 0x31u, 0x08u, 
			0x32u, 0x18u, 0x33u, 0x10u, 0x34u, 0x01u, 0x35u, 0x04u, 0x36u, 0x04u, 0x37u, 0x03u, 0x3Eu, 0x14u, 0x3Fu, 0x41u, 
			0x52u, 0x17u, 0x58u, 0x04u, 0x59u, 0x04u, 0x5Bu, 0x04u, 0x5Fu, 0x01u, 
			/* CYDEV_UCFG_B0_P2_U1_BASE */
			0x80u, 0x08u, 0x96u, 0x10u, 0x9Au, 0x02u, 0x9Eu, 0x0Du, 0xACu, 0x01u, 0xAEu, 0x02u, 0xB0u, 0x04u, 0xB2u, 0x08u, 
			0xB4u, 0x10u, 0xB6u, 0x03u, 0xBEu, 0x44u, 0xC0u, 0x02u, 0xC1u, 0x06u, 0xC5u, 0x0Au, 0xC9u, 0xFFu, 0xCAu, 0xFFu, 
			0xCBu, 0xFFu, 0xCCu, 0x02u, 0xCEu, 0xF0u, 0xD6u, 0x02u, 0xD7u, 0x13u, 0xD8u, 0x04u, 0xDAu, 0x04u, 0xDBu, 0x04u, 
			0xDEu, 0x08u, 0xDFu, 0x01u, 0xE2u, 0x48u, 0xE3u, 0xA1u, 0xE8u, 0xF0u, 0xEAu, 0xF0u, 0xECu, 0xF0u, 0xEEu, 0xF0u, 
			0x01u, 0x05u, 0x2Fu, /* Base address 0x010500 */
			/* CYDEV_UCFG_B0_P2_ROUTE_BASE */
			0x00u, 0x04u, 0x01u, 0x82u, 0x03u, 0x08u, 0x05u, 0x01u, 0x08u, 0x08u, 0x0Au, 0x4Au, 0x0Eu, 0x22u, 0x0Fu, 0x08u, 
			0x10u, 0x08u, 0x12u, 0x20u, 0x13u, 0x80u, 0x16u, 0x02u, 0x18u, 0x04u, 0x19u, 0x80u, 0x1Au, 0x40u, 0x1Bu, 0x88u, 
			0x1Cu, 0x02u, 0x1Du, 0x21u, 0x1Eu, 0x20u, 0x21u, 0x01u, 0x22u, 0x7Cu, 0x2Bu, 0x80u, 0x32u, 0x54u, 0x39u, 0x52u, 
			0x45u, 0x20u, 0x4Eu, 0x08u, 0x4Fu, 0x08u, 0x5Fu, 0x02u, 0x68u, 0x28u, 0x69u, 0x50u, 0x72u, 0x02u, 0x77u, 0x80u, 
			0x7Eu, 0x08u, 
			/* CYDEV_UCFG_B0_P2_ROUTE_BASE + 0x00000080u */
			0x85u, 0x02u, 0x86u, 0x10u, 0x87u, 0x80u, 0x9Fu, 0x02u, 0xC0u, 0x1Fu, 0xC2u, 0xEFu, 0xC4u, 0x87u, 0xCAu, 0x01u, 
			0xCCu, 0x0Eu, 0xCEu, 0x0Du, 0xD0u, 0x20u, 0xD2u, 0x20u, 0xD6u, 0x80u, 0xDEu, 0x20u, 
			0x01u, 0x06u, 0x54u, /* Base address 0x010600 */
			/* CYDEV_UCFG_B0_P3_U0_BASE */
			0x12u, 0x01u, 0x1Cu, 0x02u, 0x28u, 0x02u, 0x30u, 0x02u, 0x36u, 0x01u, 0x38u, 0x02u, 0x3Eu, 0x01u, 0x40u, 0x56u, 
			0x45u, 0x40u, 0x46u, 0x02u, 0x47u, 0x05u, 0x48u, 0x16u, 0x49u, 0xFFu, 0x4Au, 0xFFu, 0x4Bu, 0xFFu, 0x4Cu, 0x02u, 
			0x4Du, 0x20u, 0x4Fu, 0x05u, 0x51u, 0x10u, 0x58u, 0x04u, 0x5Au, 0x04u, 0x5Fu, 0x01u, 0x60u, 0x40u, 0x61u, 0x40u, 
			0x62u, 0x80u, 0x64u, 0x80u, 0x66u, 0x80u, 
			/* CYDEV_UCFG_B0_P3_U1_BASE */
			0x80u, 0x13u, 0x83u, 0x40u, 0x85u, 0x0Eu, 0x86u, 0x04u, 0x89u, 0x02u, 0x8Du, 0x06u, 0x8Eu, 0x01u, 0x8Fu, 0x08u, 
			0x90u, 0x11u, 0x91u, 0x0Cu, 0x92u, 0x02u, 0x93u, 0x02u, 0x96u, 0x08u, 0x97u, 0x10u, 0x9Au, 0x12u, 0x9Bu, 0x01u, 
			0x9Cu, 0x13u, 0x9Du, 0x0Eu, 0xA1u, 0x08u, 0xA6u, 0x08u, 0xA8u, 0x13u, 0xA9u, 0x5Au, 0xABu, 0x24u, 0xACu, 0x12u, 
			0xAEu, 0x01u, 0xAFu, 0x50u, 0xB0u, 0x04u, 0xB1u, 0x01u, 0xB2u, 0x03u, 0xB3u, 0x40u, 0xB4u, 0x08u, 0xB5u, 0x0Eu, 
			0xB6u, 0x10u, 0xB7u, 0x30u, 0xBEu, 0x54u, 0xBFu, 0x54u, 0xC0u, 0x35u, 0xC1u, 0x06u, 0xC5u, 0x20u, 0xC7u, 0x06u, 
			0xC8u, 0x12u, 0xD8u, 0x04u, 0xD9u, 0x04u, 0xDAu, 0x04u, 0xDFu, 0x01u, 0xE1u, 0x0Cu, 0xE2u, 0xF0u, 0xE3u, 0x0Cu, 
			0xE5u, 0x0Cu, 0xE7u, 0x0Cu, 0xE8u, 0x40u, 0xE9u, 0x4Cu, 0xEAu, 0x40u, 0xEBu, 0x4Cu, 0xECu, 0x90u, 0xEDu, 0x58u, 
			0xEFu, 0x0Cu, 
			0x01u, 0x07u, 0x37u, /* Base address 0x010700 */
			/* CYDEV_UCFG_B0_P3_ROUTE_BASE */
			0x01u, 0x08u, 0x03u, 0x82u, 0x0Au, 0xA6u, 0x0Eu, 0x80u, 0x0Fu, 0x01u, 0x10u, 0x24u, 0x11u, 0x40u, 0x16u, 0x08u, 
			0x19u, 0x0Au, 0x1Au, 0x85u, 0x1Eu, 0x82u, 0x20u, 0x02u, 0x21u, 0x24u, 0x22u, 0x01u, 0x28u, 0x0Cu, 0x29u, 0x41u, 
			0x2Bu, 0x08u, 0x31u, 0x28u, 0x32u, 0x41u, 0x39u, 0x40u, 0x3Au, 0x10u, 0x3Bu, 0x2Au, 0x3Du, 0x40u, 0x3Eu, 0x40u, 
			0x41u, 0x04u, 0x48u, 0x81u, 0x49u, 0x10u, 0x4Bu, 0x02u, 0x4Eu, 0x08u, 0x4Fu, 0x81u, 0x51u, 0x08u, 0x56u, 0x08u, 
			0x57u, 0x40u, 
			/* CYDEV_UCFG_B0_P3_ROUTE_BASE + 0x00000080u */
			0x87u, 0x84u, 0x90u, 0x40u, 0x92u, 0x60u, 0x96u, 0x02u, 0x9Au, 0x10u, 0x9Cu, 0x08u, 0x9Du, 0x02u, 0x9Fu, 0x02u, 
			0xA0u, 0x20u, 0xA2u, 0x08u, 0xA3u, 0x80u, 0xA6u, 0x01u, 0xACu, 0x01u, 0xB4u, 0x40u, 0xC0u, 0x0Du, 0xC2u, 0x9Fu, 
			0xC4u, 0x47u, 0xCAu, 0x0Du, 0xCCu, 0x0Fu, 0xCEu, 0x0Fu, 0xD0u, 0x02u, 0xD2u, 0x3Cu, 
			0x01u, 0x09u, 0x01u, /* Base address 0x010900 */
			/* CYDEV_UCFG_B0_P4_ROUTE_BASE + 0x00000080u */
			0xEAu, 0x40u, 
			0x01u, 0x0Du, 0x01u, /* Base address 0x010D00 */
			/* CYDEV_UCFG_B0_P6_ROUTE_BASE + 0x00000080u */
			0xE4u, 0x02u, 
			0x01u, 0x14u, 0x3Eu, /* Base address 0x011400 */
			/* CYDEV_UCFG_B1_P2_U0_BASE */
			0x0Au, 0x01u, 0x2Eu, 0x02u, 0x32u, 0x02u, 0x34u, 0x01u, 0x3Eu, 0x14u, 0x40u, 0x21u, 0x41u, 0x05u, 0x49u, 0xFFu, 
			0x4Au, 0xFFu, 0x4Bu, 0xFFu, 0x4Fu, 0x01u, 0x50u, 0x18u, 0x52u, 0x80u, 0x58u, 0x04u, 0x59u, 0x04u, 0x5Au, 0x04u, 
			0x5Bu, 0x04u, 0x5Cu, 0x10u, 0x5Du, 0x11u, 0x5Fu, 0x01u, 0x60u, 0x40u, 0x62u, 0x40u, 0x64u, 0x40u, 0x65u, 0x40u, 
			0x66u, 0x80u, 0x68u, 0x80u, 0x6Au, 0x80u, 0x6Cu, 0x80u, 0x6Eu, 0x80u, 
			/* CYDEV_UCFG_B1_P2_U1_BASE */
			0x92u, 0x01u, 0xA3u, 0x01u, 0xAEu, 0x01u, 0xB0u, 0x01u, 0xB5u, 0x01u, 0xB6u, 0x01u, 0xBEu, 0x41u, 0xC0u, 0x61u, 
			0xC1u, 0x04u, 0xC9u, 0xFFu, 0xCAu, 0xFFu, 0xCBu, 0xFFu, 0xCDu, 0x83u, 0xCEu, 0x03u, 0xCFu, 0x01u, 0xD0u, 0x18u, 
			0xD4u, 0x03u, 0xD8u, 0x04u, 0xD9u, 0x04u, 0xDAu, 0x04u, 0xDBu, 0x04u, 0xDCu, 0x10u, 0xDDu, 0x11u, 0xDFu, 0x05u, 
			0xE0u, 0x40u, 0xE2u, 0x40u, 0xE4u, 0x40u, 0xE5u, 0x40u, 0xE6u, 0x80u, 0xE8u, 0x80u, 0xEAu, 0x80u, 0xECu, 0x80u, 
			0xEEu, 0x80u, 
			0x01u, 0x15u, 0x2Fu, /* Base address 0x011500 */
			/* CYDEV_UCFG_B1_P2_ROUTE_BASE */
			0x00u, 0x10u, 0x0Fu, 0x40u, 0x13u, 0x40u, 0x16u, 0x02u, 0x18u, 0x10u, 0x1Au, 0x08u, 0x1Bu, 0x20u, 0x1Eu, 0x80u, 
			0x1Fu, 0x80u, 0x26u, 0x10u, 0x2Fu, 0x80u, 0x34u, 0x01u, 0x37u, 0x02u, 0x3Bu, 0x40u, 0x42u, 0x02u, 0x43u, 0x20u, 
			0x46u, 0x02u, 0x47u, 0x01u, 0x48u, 0x02u, 0x4Eu, 0x04u, 0x5Du, 0x25u, 0x5Eu, 0x80u, 0x64u, 0x01u, 0x65u, 0x20u, 
			0x67u, 0x20u, 0x6Cu, 0x02u, 0x6Fu, 0x03u, 0x73u, 0x40u, 0x7Fu, 0x02u, 
			/* CYDEV_UCFG_B1_P2_ROUTE_BASE + 0x00000080u */
			0x85u, 0x20u, 0x87u, 0x12u, 0x91u, 0x05u, 0x96u, 0x08u, 0x9Au, 0x02u, 0x9Bu, 0x02u, 0x9Fu, 0x01u, 0xA6u, 0x10u, 
			0xC0u, 0x02u, 0xC2u, 0x10u, 0xC4u, 0x81u, 0xCAu, 0x80u, 0xCEu, 0x08u, 0xD0u, 0x9Cu, 0xD2u, 0x28u, 0xD6u, 0xF0u, 
			0xD8u, 0x70u, 0xDEu, 0x10u, 
			0x01u, 0x16u, 0x4Du, /* Base address 0x011600 */
			/* CYDEV_UCFG_B1_P3_U0_BASE */
			0x01u, 0x02u, 0x11u, 0x01u, 0x31u, 0x01u, 0x33u, 0x02u, 0x3Fu, 0x45u, 0x40u, 0x61u, 0x41u, 0x04u, 0x45u, 0xECu, 
			0x47u, 0x20u, 0x48u, 0x23u, 0x49u, 0xFFu, 0x4Au, 0xFFu, 0x4Bu, 0xFFu, 0x4Du, 0x83u, 0x4Eu, 0x03u, 0x4Fu, 0x01u, 
			0x50u, 0x18u, 0x56u, 0x08u, 0x59u, 0x04u, 0x5Au, 0x04u, 0x5Bu, 0x0Eu, 0x5Du, 0x01u, 0x5Fu, 0x01u, 0x60u, 0x40u, 
			0x62u, 0x40u, 0x64u, 0x40u, 0x65u, 0x40u, 0x66u, 0x80u, 0x68u, 0x80u, 0x6Au, 0x80u, 0x6Cu, 0x80u, 0x6Eu, 0x80u, 
			/* CYDEV_UCFG_B1_P3_U1_BASE */
			0x80u, 0x08u, 0x84u, 0x01u, 0x87u, 0x10u, 0x8Eu, 0x01u, 0x8Fu, 0x04u, 0x92u, 0x08u, 0x93u, 0x16u, 0x95u, 0x16u, 
			0x96u, 0x04u, 0x97u, 0x08u, 0x9Eu, 0x02u, 0x9Fu, 0x01u, 0xA2u, 0x04u, 0xADu, 0x01u, 0xB0u, 0x04u, 0xB1u, 0x01u, 
			0xB2u, 0x02u, 0xB3u, 0x10u, 0xB4u, 0x01u, 0xB5u, 0x0Cu, 0xB6u, 0x08u, 0xB7u, 0x02u, 0xBEu, 0x51u, 0xBFu, 0x55u, 
			0xC0u, 0x32u, 0xC1u, 0x05u, 0xC6u, 0x06u, 0xC7u, 0x02u, 0xC8u, 0x14u, 0xD8u, 0x04u, 0xD9u, 0x04u, 0xDAu, 0x04u, 
			0xDFu, 0x01u, 0xE1u, 0x0Cu, 0xE2u, 0xF0u, 0xE3u, 0x0Cu, 0xE5u, 0x0Cu, 0xE7u, 0x0Cu, 0xE8u, 0x40u, 0xE9u, 0x4Cu, 
			0xEAu, 0x40u, 0xEBu, 0x4Cu, 0xECu, 0x90u, 0xEDu, 0x58u, 0xEFu, 0x0Cu, 
			0x01u, 0x17u, 0x32u, /* Base address 0x011700 */
			/* CYDEV_UCFG_B1_P3_ROUTE_BASE */
			0x01u, 0x8Au, 0x09u, 0x08u, 0x0Au, 0x41u, 0x10u, 0x80u, 0x19u, 0xDBu, 0x1Bu, 0x0Au, 0x20u, 0x06u, 0x21u, 0x06u, 
			0x25u, 0x01u, 0x27u, 0x22u, 0x28u, 0x01u, 0x31u, 0x42u, 0x33u, 0x08u, 0x34u, 0x01u, 0x38u, 0x88u, 0x3Du, 0x02u, 
			0x40u, 0x04u, 0x41u, 0x04u, 0x46u, 0x02u, 0x47u, 0x01u, 0x48u, 0x01u, 0x4Du, 0x05u, 0x4Eu, 0x04u, 0x50u, 0x44u, 
			0x56u, 0x02u, 0x5Cu, 0x40u, 0x64u, 0x01u, 0x7Fu, 0x10u, 
			/* CYDEV_UCFG_B1_P3_ROUTE_BASE + 0x00000080u */
			0x8Au, 0x10u, 0x8Bu, 0x20u, 0x90u, 0x40u, 0x92u, 0x41u, 0x93u, 0x20u, 0x9Du, 0x51u, 0x9Fu, 0x02u, 0xA0u, 0x80u, 
			0xA1u, 0x08u, 0xA7u, 0x0Au, 0xC0u, 0x0Du, 0xC2u, 0x0Du, 0xC4u, 0x08u, 0xCAu, 0x08u, 0xCCu, 0x8Bu, 0xCEu, 0x8Au, 
			0xD0u, 0x96u, 0xD2u, 0x28u, 0xD6u, 0x10u, 0xD8u, 0x10u, 0xDEu, 0x40u, 0xE2u, 0x80u, 
			0x01u, 0x19u, 0x01u, /* Base address 0x011900 */
			/* CYDEV_UCFG_B1_P4_ROUTE_BASE + 0x00000080u */
			0xE4u, 0x20u, 
			0x01u, 0x40u, 0x05u, /* Base address 0x014000 */
			/* CYDEV_UCFG_DSI0_BASE */
			0x31u, 0x40u, 0x34u, 0x40u, 0x7Bu, 0x01u, 
			/* CYDEV_UCFG_DSI0_BASE + 0x00000080u */
			0xCCu, 0x30u, 0xDCu, 0x80u, 
			0x01u, 0x41u, 0x09u, /* Base address 0x014100 */
			/* CYDEV_UCFG_DSI1_BASE */
			0x58u, 0x10u, 0x5Cu, 0x02u, 
			/* CYDEV_UCFG_DSI1_BASE + 0x00000080u */
			0x84u, 0x12u, 0x9Cu, 0x40u, 0x9Du, 0x40u, 0xA7u, 0x01u, 0xD4u, 0x80u, 0xD6u, 0x80u, 0xE6u, 0x40u, 
			0x01u, 0x42u, 0x05u, /* Base address 0x014200 */
			/* CYDEV_UCFG_DSI2_BASE + 0x00000080u */
			0x85u, 0x40u, 0x9Cu, 0x40u, 0x9Du, 0x40u, 0xA7u, 0x01u, 0xE6u, 0x10u, 
			0x01u, 0x43u, 0x03u, /* Base address 0x014300 */
			/* CYDEV_UCFG_DSI3_BASE + 0x00000080u */
			0x9Cu, 0x40u, 0xAFu, 0x01u, 0xEEu, 0x10u, 
			0x01u, 0x44u, 0x05u, /* Base address 0x014400 */
			/* CYDEV_UCFG_DSI4_BASE */
			0x36u, 0x40u, 0x37u, 0x02u, 0x3Au, 0x80u, 
			/* CYDEV_UCFG_DSI4_BASE + 0x00000080u */
			0xCCu, 0x05u, 0xCEu, 0x08u, 
			0x01u, 0x45u, 0x05u, /* Base address 0x014500 */
			/* CYDEV_UCFG_DSI5_BASE + 0x00000080u */
			0x86u, 0x40u, 0x87u, 0x02u, 0x9Eu, 0x80u, 0x9Fu, 0x02u, 0xA6u, 0x40u, 
			0x01u, 0x46u, 0x03u, /* Base address 0x014600 */
			/* CYDEV_UCFG_DSI6_BASE */
			0x00u, 0x40u, 
			/* CYDEV_UCFG_DSI6_BASE + 0x00000080u */
			0x9Eu, 0x80u, 0xC0u, 0x02u, 
			0x01u, 0x47u, 0x03u, /* Base address 0x014700 */
			/* CYDEV_UCFG_DSI7_BASE + 0x00000080u */
			0x9Eu, 0x80u, 0xB4u, 0x40u, 0xEAu, 0x02u, 
			0x01u, 0x48u, 0x02u, /* Base address 0x014800 */
			/* CYDEV_UCFG_DSI8_BASE + 0x00000080u */
			0x88u, 0x40u, 0x9Cu, 0x40u, 
			0x01u, 0x4Cu, 0x03u, /* Base address 0x014C00 */
			/* CYDEV_UCFG_DSI12_BASE + 0x00000080u */
			0x8Au, 0x80u, 0x9Eu, 0x80u, 0xE4u, 0x04u, 
			0x01u, 0x50u, 0x04u, /* Base address 0x015000 */
			/* CYREG_BCTL0_MDCLK_EN */
			0x00u, 0x01u, 0x0Au, 0x01u, 
			/* CYREG_BCTL1_MDCLK_EN */
			0x10u, 0x03u, 0x1Au, 0x03u, 
			0x01u, 0x51u, 0x01u, /* Base address 0x015100 */
			/* CYREG_IDMUX_IRQ_CTL0 */
			0x00u, 0x0Fu, 
		};
		/* BYTES: 1194 */


		typedef struct {
			void CYFAR *address;
			uint16 size;
		} CYPACKED cfg_memset_t;

		static const cfg_memset_t CYCODE cfg_memset_list [] = {
			/* address, size */
			{(void CYFAR *)(CYREG_PRT3_DR), 64u},
			{(void CYFAR *)(CYREG_PRT12_DR), 16u},
			{(void CYFAR *)(CYREG_PRT15_DR), 16u},
			{(void CYFAR *)(CYDEV_UCFG_B0_P0_U0_BASE), 4096u},
			{(void CYFAR *)(CYDEV_UCFG_B1_P2_U0_BASE), 2048u},
			{(void CYFAR *)(CYDEV_UCFG_DSI0_BASE), 2560u},
			{(void CYFAR *)(CYDEV_UCFG_DSI12_BASE), 512u},
			{(void CYFAR *)(CYREG_BCTL0_MDCLK_EN), 32u},
		};

		uint8 CYDATA i;

		/* Zero out critical memory blocks before beginning configuration */
		for (i = 0u; i < (sizeof(cfg_memset_list)/sizeof(cfg_memset_list[0])); i++)
		{
			const cfg_memset_t CYCODE * CYDATA ms = &cfg_memset_list[i];
			CYMEMZERO(ms->address, ms->size);
		}

		cfg_write_bytes_code(cfg_byte_table);

		/* Perform normal device configuration. Order is not critical for these items. */
		CY_SET_XTND_REG16((void CYFAR *)(CYREG_CAPSL_CFG0), 0x0300u);
		CY_SET_XTND_REG16((void CYFAR *)(CYREG_LUT2_CR), 0x0203u);

		/* Enable digital routing */
		CY_SET_XTND_REG8((void CYFAR *)CYREG_BCTL0_BANK_CTL, CY_GET_XTND_REG8((void CYFAR *)CYREG_BCTL0_BANK_CTL) | 0x02u);
		CY_SET_XTND_REG8((void CYFAR *)CYREG_BCTL1_BANK_CTL, CY_GET_XTND_REG8((void CYFAR *)CYREG_BCTL1_BANK_CTL) | 0x02u);

		/* Enable UDB array */
		CY_SET_REG8((void CYXDATA *)CYREG_PM_ACT_CFG0, CY_GET_REG8((void CYXDATA *)CYREG_PM_ACT_CFG0) | 0x40u);
		CY_SET_REG8((void CYXDATA *)CYREG_PM_AVAIL_CR2, CY_GET_REG8((void CYXDATA *)CYREG_PM_AVAIL_CR2) | 0x10u);
	}

	/* Perform second pass device configuration. These items must be configured in specific order after the regular configuration is done. */
	CYCONFIGCPYCODE((void CYFAR *)(CYREG_PRT0_DM0), (const void CYCODE *)(BS_IOPINS0_0_VAL), 8u);
	CYCONFIGCPYCODE((void CYFAR *)(CYREG_PRT1_DM0), (const void CYCODE *)(BS_IOPINS0_1_VAL), 8u);
	CYCONFIGCPYCODE((void CYFAR *)(CYREG_PRT2_DM0), (const void CYCODE *)(BS_IOPINS0_2_VAL), 8u);
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_B0_P2_U1_CFG27), 0x44u);
	CY_SET_REG8((void CYXDATA *)(CYREG_INTC_CSR_EN), 0x01u);

	/* Switch Boost to the precision bandgap reference from its internal reference */
	CY_SET_REG8((void CYXDATA *)CYDEV_BOOST_CR2, (CY_GET_REG8((void CYXDATA *)CYDEV_BOOST_CR2) | 0x08u));
	if (CYDEV_CHIP_REV_ACTUAL < 5u)
	{
		CY_SET_REG8((void CYXDATA *)CYDEV_MFGCFG_PWRSYS_WAKE_TR2, 0x3Au);
	}


	/* Set Flash Cycles based on max possible frequency in case a glitch occurs during ClockSetup(). */
	CY_SET_REG8((void CYXDATA *)(CYREG_CACHE_CR), (((CYDEV_INSTRUCT_CACHE_ENABLED) != 0) ? 0xF1u : 0xC0u));
	/* Setup clocks based on selections from Clock DWR */
	ClockSetup();
	/* Set Flash Cycles based on newly configured 24.00MHz Bus Clock. */
	CY_SET_REG8((void CYXDATA *)(CYREG_CACHE_CR), (((CYDEV_INSTRUCT_CACHE_ENABLED) != 0) ? 0xB1u : 0x80u));

	/* Perform basic analog initialization to defaults */
	AnalogSetDefault();

	/* Configure alternate active mode */
	CYCONFIGCPY((void CYFAR *)CYDEV_PM_STBY_BASE, (const void CYFAR *)CYDEV_PM_ACT_BASE, 14u);
	CY_SET_REG8((void CYXDATA *)CYREG_PM_STBY_CFG0, CY_GET_REG8((void CYXDATA *)CYREG_PM_STBY_CFG0) & (uint8)~0x02u);	/* Disable CPU */
}
